import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_AttachLoadBalancerTargetGroupsCommand, se_AttachLoadBalancerTargetGroupsCommand, } from "../protocols/Aws_query";
export { $Command };
export class AttachLoadBalancerTargetGroupsCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("AutoScaling_2011_01_01", "AttachLoadBalancerTargetGroups", {})
    .n("AutoScalingClient", "AttachLoadBalancerTargetGroupsCommand")
    .f(void 0, void 0)
    .ser(se_AttachLoadBalancerTargetGroupsCommand)
    .de(de_AttachLoadBalancerTargetGroupsCommand)
    .build() {
}
